/*
 * grader-io - uart-nxp.h
 *
 * Copyright (C) 2016..2017  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifndef UART_NXP_INCLUDED
#define UART_NXP_INCLUDED

#include <tty.h>

#define UART_RX_BUF_SIZE	16
#define UART_TX_BUF_SIZE	16

struct uart {
	u32 __iomem *regs;

	unsigned int ier;

	u32 tx_buf[UART_TX_BUF_SIZE / 4];
	unsigned int tx_head;
	unsigned int tx_tail;

	struct tty_struct tty;
};

void uart_init(struct uart *p, unsigned long addr, unsigned int irq,
		unsigned int div);
void uart_irq_handler(struct uart *p) __attribute__((hot));

#endif
