/*
 * grader-rt - nxp-qei.c
 *
 * Copyright (C) 2017  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <kernel.h>
#include <asm_io.h>
#include <lpc176x.h>
#include <gpio.h>

#define QEI_BASE		0x400bc000

#define QEICON			0x000
#define QEISTAT			0x004
#define QEICONF			0x008
#define QEICONF_DIRINV		0x00000001
#define QEICONF_CAPMODE		0x00000004
#define QEIPOS			0x00c
#define QEIMAXPOS		0x010

unsigned long encoder_get_pos(void)
{
	return readl((u32 *) (QEI_BASE + QEIPOS));
}

int encoder_init(void)
{
	writel(QEICONF_CAPMODE | QEICONF_DIRINV, (u32 *) (QEI_BASE + QEICONF));
	writel(0xffffffff, (u32 *) (QEI_BASE + QEIMAXPOS));
	return 0;
}
